%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% I, the copyright holder of this work, release this work into the
%% public domain. This applies worldwide. In some countries this may
%% not be legally possible; if so: I grant anyone the right to use
%% this work for any purpose, without any conditions, unless such
%% conditions are required by law.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\documentclass[
  digital, %% The `digital` option enables the default options for the
           %% digital version of a document. Replace with `printed`
           %% to enable the default options for the printed version
           %% of a document.
%%  color,   %% Uncomment these lines (by removing the %% at the
%%           %% beginning) to use color in the printed version of your
%%           %% document
  oneside, %% The `oneside` option enables one-sided typesetting,
           %% which is preferred if you are only going to submit a
           %% digital version of your thesis. Replace with `twoside`
           %% for double-sided typesetting if you are planning to
           %% also print your thesis. For double-sided typesetting,
           %% use at least 120 g/m² paper to prevent show-through.
  nolof,     %% The `lof` option prints the List of Figures. Replace
           %% with `nolof` to hide the List of Figures.
  nolot,     %% The `lot` option prints the List of Tables. Replace
           %% with `nolot` to hide the List of Tables.
]{fithesis4}
%% The following section sets up the locales used in the thesis.
\usepackage[resetfonts]{cmap} %% We need to load the T2A font encoding
\usepackage[T1,T2A]{fontenc}  %% to use the Cyrillic fonts with Russian texts.
\usepackage[
  main=english, %% By using `czech` or `slovak` as the main locale
                %% instead of `english`, you can typeset the thesis
                %% in either Czech or Slovak, respectively.
  english, german, russian, czech, slovak %% The additional keys allow
]{babel}        %% foreign texts to be typeset as follows:
%%
%%   \begin{otherlanguage}{german}  ... \end{otherlanguage}
%%   \begin{otherlanguage}{russian} ... \end{otherlanguage}
%%   \begin{otherlanguage}{czech}   ... \end{otherlanguage}
%%   \begin{otherlanguage}{slovak}  ... \end{otherlanguage}
%%
%% For non-Latin scripts, it may be necessary to load additional
%% fonts:
\usepackage{paratype}
\def\textrussian#1{{\usefont{T2A}{PTSerif-TLF}{m}{rm}#1}}
%%
%% The following section sets up the metadata of the thesis.
\thesissetup{
    date        = \the\year/\the\month/\the\day,
    university  = mu,
    faculty     = fi,
    type        = mgr,
    department  = Department of Computer Systems and Communications,
    author      = Bc. Daniel Zaťovič,
    gender      = m,
    advisor     = {Ing. Milan Brož, Ph.D.},
    title       = {Cryptsetup fuzzing within the OSS-Fuzz project},
    TeXtitle    = {Cryptsetup fuzzing within the OSS-Fuzz project},
    keywords    = {fuzzing, cryptsetup, OSS-Fuzz, custom mutator},
    TeXkeywords = {fuzzing, \texttt{cryptsetup}, OSS-Fuzz, custom mutator},
    abstract    = {%
      Full disk encryption tools were designed to protect the privacy of the
      growing amount of sensitive data stored on computers. As with every piece
      of software, these utilities are also prone to bugs and security
      vulnerabilities. Fuzz testing is a proven and efficient way to discover
      and locate such mistakes. The OSS-Fuzz provides a free distributed
      fuzzing infrastructure for open source projects. We have implemented fuzz
      targets that enable fuzzing of the on-disk metadata stored and parsed by
      the cryptsetup utility. We propose a LUKS2 format-specific custom mutator
      to allow the fuzzer to generate more advanced test cases. The solution
      was integrated with the cryptsetup build system. Finally, we have
      designed a Docker image for cryptsetup building within the OSS-Fuzz
      infrastructure.
    },
    thanks      = {%
      First and foremost, I wish to thank the supervisor of this thesis, Ing.
      Milan Brož, Ph.D. for all the precious advice he has given me during the
      writing of this thesis. I would also like to thank him for guiding and
      mentoring me almost from the beginning of my studies. Thank you!

      I want to thank Red Hat, Inc., namely managers Jonathan Brassow and
      Dennis Keefe, for providing me with computational resources used for
      experimentation during the writing of this thesis and for giving me time
      to work on the fuzzing of \texttt{cryptsetup}.

      I would also like to thank everybody who has supported me throughout my
      studies.
    },
    bib         = bibliography.bib,
    %% Remove the following line to use the JVS 2018 faculty logo.
    facultyLogo = fithesis-fi,
}
\usepackage{makeidx}      %% The `makeidx` package contains
\makeindex                %% helper commands for index typesetting.
\usepackage[acronym]{glossaries}          %% The `glossaries` package
\renewcommand*\glspostdescription{\hfill} %% contains helper commands
\loadglsentries{glossary.tex}  %% for typesetting glossaries
\makenoidxglossaries                      %% and lists of abbreviations.
%% These additional packages are used within the document:
\usepackage{paralist} %% Compact list environments
\usepackage{amsmath}  %% Mathematics
\usepackage{amsthm}
\usepackage{amsfonts}
\usepackage{url}      %% Hyperlinks
\usepackage{markdown} %% Lightweight markup
\usepackage{listings} %% Source code highlighting
\usepackage{xcolor}
\usepackage{bytefield}
\usepackage{rotating}
\usepackage{multirow}
\usepackage{makecell}
\usepackage{tikz}
\usetikzlibrary{shapes,arrows}

\newcommand{\bitlabel}[2]{\bitbox[]{#1}
{\raisebox{0pt}[0ex][0pt]{\turnbox{0}{\fontsize{8}{8}\selectfont#2}}}}

\lstset{
  basicstyle      = \ttfamily,
  identifierstyle = \color{black},
  keywordstyle    = \color{blue},
  keywordstyle    = {[2]\color{cyan}},
  keywordstyle    = {[3]\color{olive}},
  stringstyle     = \color{teal},
  commentstyle    = \itshape\color{magenta},
  breaklines      = true,
}

\definecolor{brickred}{rgb}{0.8, 0.25, 0.33}

\colorlet{punct}{red!60!black}
\definecolor{delim}{RGB}{20,105,176}
\colorlet{numb}{magenta!60!black}

\lstdefinelanguage{yaml}{
  basicstyle=\footnotesize\ttfamily,
  numbers=left,
  numberstyle=\scriptsize,
  stepnumber=1,
  numbersep=8pt,
  keywords={true,false,null,y,n},
  keywordstyle=\color{darkgray},
  ndkeywords={},
  ndkeywordstyle=\color{black},
  identifierstyle=\color{black},
  sensitive=false,
  %moredelim=[l]{}{:},
  morecomment=[s]{/*}{*/},
  commentstyle=\color{purple}\ttfamily,
  stringstyle=\color{blue}\ttfamily,
  %morestring=[l]{-}{},
  morestring=[b]',
  morestring=[b]"
}

\lstdefinelanguage{json}{
%    basicstyle=\normalfont\ttfamily,
    basicstyle=\footnotesize\ttfamily,
    numbers=left,
    numberstyle=\scriptsize,
    stepnumber=1,
    numbersep=8pt,
%    showstringspaces=false,
%    breaklines=true,
    morekeywords={keyslots,segments,config,digests,tokens,type},
    keywordstyle=\color{red!40!black},
    literate=
      {,}{{{\color{punct}{,}}}}{1}
      {\{}{{{\color{delim}{\{}}}}{1}
      {\}}{{{\color{delim}{\}}}}}{1}
      {[}{{{\color{delim}{[}}}}{1}
      {]}{{{\color{delim}{]}}}}{1},
%    string=[s]{"}{"},
%    stringstyle=\color{black},
    comment=[l]{:},
    commentstyle=\color{gray},
}

\lstdefinestyle{customc}{
%  belowcaptionskip=1\baselineskip,
%  breaklines=true,
%  frame=L,
%  xleftmargin=\parindent,
  numbers=left,
  numberstyle=\scriptsize,
  language=C,
  showstringspaces=false,
  basicstyle=\footnotesize\ttfamily,
  keywordstyle=\ttfamily\color{green!40!black},
  commentstyle=\itshape\color{purple!40!black},
  identifierstyle=\ttfamily\color{blue},
  stringstyle=\color{orange},
}

\lstdefinelanguage[2]{protobuf}{%
    sensitive=true,%
    morecomment=[l]{//},%
    morecomment=[s]{/*}{*/},%
    morestring=[b]{"},%
    % For the keywords of Protocol Buffers
    % see https://developers.google.com/protocol-buffers/docs/proto
    morekeywords={enum,oneof,map,syntax,public,import,option,package,message,%
        group,optional,required,repeated,default,reserved,extend,extensions,%
        to,max,service,rpc,returns,true,false},%
    % Basic types
    % see https://developers.google.com/protocol-buffers/docs/proto#scalar
    morekeywords=[2]{%
        double,float,int32,int64,uint32,uint64,sint32,sint64,%
        fixed32,fixed64,sfixed32,sfixed64,bool,string,bytes},%
    % Options
    % taken from 'google/protobuf/descriptor.proto'
    morekeywords=[3]{%
        % Generic Options
        deprecated, uninterpreted_option,%
        % File Options
        java_package,java_outer_classname,java_multiple_files,%
        java_generate_equals_and_hash,java_string_check_utf8,optimize_for,%
        go_package,cc_generic_services,java_generic_services,%
        py_generic_services,cc_enable_arenas,obj_class_prefix,%
        csharp_namespace,%
        % Message Options
        message_set_wire_format,no_standard_descriptor_accessor,map_entry,%
        % Field Options
        ctype, packed,jstype,lazy,weak,%
        % Enum Options
        allow_alias}%
}
\lstalias[]{protobuf2}[2]{protobuf}

\usepackage{floatrow} %% Putting captions above tables
\floatsetup[table]{capposition=top}
\usepackage[babel]{csquotes} %% Context-sensitive quotation marks
\begin{document}
%% Uncomment the following lines (by removing the %% at the beginning)
%% and to print out List of Abbreviations and/or Glossary in your
%% document. Titles for these tables can be changed by replacing the
%% titles `Abbreviations` and `Glossary`, respectively.
%% \clearpage
%% \printnoidxglossary[title={Abbreviations}, type=\acronymtype]
%% \printnoidxglossary[title={Glossary}]

\setcounter{biburllcpenalty}{7000}
\setcounter{biburlucpenalty}{8000}

\input{chapters/introduction.tex}
\input{chapters/fuzzing.tex}
\input{chapters/oss-fuzz.tex}
\input{chapters/cryptsetup.tex}
\providecommand{\tightlist}{%
  \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}
\input{chapters/practical.tex}
\input{chapters/conclusion.tex}

%% Bibliography
\printbibliography[heading=bibintoc] %% Print the bibliography.

%% Index
% \makeatletter\thesis@blocks@clear\makeatother
% \phantomsection %% Print the index and insert it into the
% \addcontentsline{toc}{chapter}{\indexname} %% table of contents.
% \printindex

\appendix %% Start the appendices.
\chapter{An appendix}
\input{figures/crypt2_load_fuzz.tex}
\input{figures/luks2_proto.tex}

\end{document}
